From: Zorro Lang <zlang@kernel.org>
To: fstests@vger.kernel.org
Cc: linux-xfs@vger.kernel.org
Subject: [PATCH] generic: shutdown might leave NULL files with nonzero di_size
Date: Sat, 5 Nov 2022 00:20:02 +0800 [thread overview]
Message-ID: <20221104162002.1912751-1-zlang@kernel.org> (raw)
An old issue might cause on-disk inode sizes are logged prematurely
via the free eofblocks path on file close. Then fs shutdown might
leave NULL files but their di_size > 0.
Signed-off-by: Zorro Lang <zlang@kernel.org>
---
Hi,
There was an very old xfs bug on rhel-6.5, I'd like to share its reproducer to
fstests. I've tried generic/044~049, no one can reproduce this bug, so I
have to write this new one. It fails on rhel-6.5 [1], and test passed on
later kernel.
I hard to say which patch fix this issue exactly, it's fixed by a patchset
which does code improvement/cleanup.
Thanks,
Zorro
[1]
# ./check generic/999
FSTYP -- xfs (non-debug)
PLATFORM -- Linux/x86_64
MKFS_OPTIONS -- -f -bsize=4096 /dev/loop1
MOUNT_OPTIONS -- -o context=system_u:object_r:nfs_t:s0 /dev/loop1 /mnt/scratch
generic/999 2s ... - output mismatch (see /root/xfstests-dev/results//generic/999.out.bad)
--- tests/generic/999.out 2022-11-04 00:54:11.123353054 -0400
+++ /root/xfstests-dev/results//generic/999.out.bad 2022-11-04 04:24:57.861673433 -0400
@@ -1 +1,3 @@
QA output created by 999
+ - /mnt/scratch/1 get no extents, but its di_size > 0
+/mnt/scratch/1:
...
(Run 'diff -u tests/generic/045.out /root/xfstests-dev/results//generic/999.out.bad' to see the entire diff)
Ran: generic/999
Failures: generic/999
Failed 1 of 1 tests
tests/generic/999 | 46 +++++++++++++++++++++++++++++++++++++++++++
tests/generic/999.out | 5 +++++
2 files changed, 51 insertions(+)
create mode 100755 tests/generic/999
create mode 100644 tests/generic/999.out
diff --git a/tests/generic/999 b/tests/generic/999
new file mode 100755
index 00000000..a2e662fc
--- /dev/null
+++ b/tests/generic/999
@@ -0,0 +1,46 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2022 Red Hat, Inc. All Rights Reserved.
+#
+# FS QA Test No. 999
+#
+# Test an issue in the truncate codepath where on-disk inode sizes are logged
+# prematurely via the free eofblocks path on file close.
+#
+. ./common/preamble
+_begin_fstest auto quick shutdown
+
+# real QA test starts here
+_supported_fs xfs
+_require_scratch
+_require_xfs_io_command fiemap
+_require_scratch_shutdown
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+echo "Create many small files with one extent at least"
+for ((i=0; i<10000; i++));do
+ $XFS_IO_PROG -f -c "pwrite 0 4k" $SCRATCH_MNT/file.$i >/dev/null 2>&1
+done
+
+echo "Shutdown the fs suddently"
+_scratch_shutdown
+
+echo "Cycle mount"
+_scratch_cycle_mount
+
+echo "Check file's (di_size > 0) extents"
+for f in $(find $SCRATCH_MNT -type f -size +0);do
+ $XFS_IO_PROG -c "fiemap" $f > $tmp.fiemap
+ # Check if the file has any extent
+ grep -Eq '^[[:space:]]+[0-9]+:' $tmp.fiemap
+ if [ $? -ne 0 ];then
+ echo " - $f get no extents, but its di_size > 0"
+ cat $tmp.fiemap
+ break
+ fi
+done
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/999.out b/tests/generic/999.out
new file mode 100644
index 00000000..50008783
--- /dev/null
+++ b/tests/generic/999.out
@@ -0,0 +1,5 @@
+QA output created by 999
+Create many small files with one extent at least
+Shutdown the fs suddently
+Cycle mount
+Check file's (di_size > 0) extents
--
2.31.1
next reply other threads:[~2022-11-04 16:20 UTC|newest]
Thread overview: 4+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-11-04 16:20 Zorro Lang [this message]
2022-11-04 16:29 ` [PATCH] generic: shutdown might leave NULL files with nonzero di_size Darrick J. Wong
2022-11-05 12:16 ` Zorro Lang
2022-11-05 12:28 ` Zorro Lang
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20221104162002.1912751-1-zlang@kernel.org \
--to=zlang@kernel.org \
--cc=fstests@vger.kernel.org \
--cc=linux-xfs@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox